/******************************************************************************
*  PROGRAM:  Santa's Secret                                                   *
*  AUTHOR:   Steven Silvey                                                    *
*  DATE CREATED: 12/18/2005                                                   *
*  DATE MODIFIED:  ????????                                                   *
*  DESCRIPTION:                                                               *
*  MODIFICATION NOTES:                                                        *
*                                                                             *
******************************************************************************/

/*#include "allegro.h"
#include "allegro_keyboard.h"
#include "allegro_color.h"
#include "constant.h"
#include<iostream>
#include<stdlib.h>
#include<stdio.h>*/

#include "allegro.h"
#include "allegro_color.h"
#include "test.h"
#include "game.h"


void init();
void game_mode();

int main()
{
	game SS;
	bool quit = false;
	
	// Setup allegro
	init();

	// Choose the screen-mode:  Windowed or Full Screen
	game_mode();

	// The "handle-game" loop
	while(!key[KEY_ESC] && quit == false)
	{
		quit = SS.options();
		if(quit != true) SS.play();	
	}

	return 0;
}

void game_mode()
{
	DATAFILE *dDat;
	BITMAP *bTitle;
	int curx, cury;
	int mode = 0;
	MIDI *song;

	show_mouse(screen);
	
	//dDat = load_datafile(".\\Data\\GFX\\test.dat");
	//if(!dDat)
	//{
	//	allegro_message("Data file didn't load!");
	//exit(0);
	//}
	bTitle = load_bitmap(".\\Data\\GFX\\title.pcx", NULL);
	draw_sprite(screen, bTitle, 0, 0);

	song = load_midi(".\\Data\\Music\\sleighrd.mid");
		
	if(song == NULL)
		allegro_message("Failed to load midi song: sleighrd.mid");
	
	play_looped_midi(song, 0, -1);
	curx = mouse_x;
	cury = mouse_y;
	while(!key[KEY_ENTER] && mode == 0)
	{
		if(mouse_b & 1) 
		{
			if(mouse_x > 100 && mouse_x < 250 
				&& mouse_y > 310 && mouse_y < 375)
				mode = 1;
			if(mouse_x > 360 && mouse_x < 500 
				&& mouse_y > 310 && mouse_y < 375)
				mode = 2;
		}		
	}
	stop_midi();
	destroy_midi(song);
	clear(screen);
	destroy_bitmap(bTitle);
	//unload_datafile(dDat);

	switch(mode)
	{
	case 1:
		//NOTE:  Already in windowed mode!
		break;
	case 2:
		//  Switch to full screen!
		GFX_W = 640;
		GFX_H = 480;
		set_color_depth(16) ; // 24 bit colour
		//debug("Initializeing GFX...");
		if (set_gfx_mode(GFX_AUTODETECT, GFX_W, GFX_H, 0, 0)<0)
		{
			set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
			allegro_message("ERROR:  Failure to init video mode!  Terminating program.\n");
			allegro_message("REPORT:  %s\n", allegro_error);
			exit(0);
		}
		//debug("GFX Initialized successfully!");
		break;
	}
}

void init()
{
	//  Allegro Library
	//debug("Begin Allegro Init...");
	if(allegro_init() != 0)
	{
		allegro_message("ERROR:  Failed to initialize allegro library.  Terminating program.\n");
		allegro_message("REPORT:  %s\n", allegro_error);
		exit(0);
	}
	//debug("Allegro Init Successful!");

	//  Set GFX
	GFX_W = 640;
	GFX_H = 480;
	set_color_depth(24) ; // 24 bit colour
	//debug("Initializeing GFX...");
	if (set_gfx_mode(GFX_AUTODETECT, GFX_W, GFX_H, 0, 0)<0)
	{
		set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
		allegro_message("ERROR:  Failure to init video mode!  Terminating program.\n");
		allegro_message("REPORT:  %s\n", allegro_error);
		exit(0);
	}
	//debug("GFX Initialized successfully!");

	//  Install Keyboard
	//debug("Installing keyboard...");
	if(install_timer() != 0)
	{
		allegro_message("ERROR:  Failed to install timer.  Terminating program.\n");
		allegro_message("REPORT:  %s\n", allegro_error);
		exit(0);
	}
	//debug("Keyboard Installed Successfully!");


	//  Install Keyboard
	//debug("Installing keyboard...");
	if(install_keyboard() != 0)
	{
		allegro_message("ERROR:  Failed to install keyboard.  Terminating program.\n");
		allegro_message("REPORT:  %s\n", allegro_error);
		exit(0);
	}
	//debug("Keyboard Installed Successfully!");

	//  Install Mouse
	if(install_mouse() < 0)
	{
		allegro_message("ERROR:  Failed to install mouse.  Terminating program.\n");
		allegro_message("REPORT:  %s\n", allegro_error);
		exit(0);
	}
	
	text_mode(MASK);	
	reserve_voices(32,-1); ///Reserves more channels of sound for us
	
	//  Install Sound
	//debug("Installing Sound...");
	if(install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, NULL) != 0)	
	{
		allegro_message("ERROR:  Failure to install sound.  Attempting to run without sound.\n");
		allegro_message("REPORT:  %s\n", allegro_error);
		if(install_sound(DIGI_NONE, MIDI_NONE, NULL) != 0)
		{
			allegro_message("ERROR:  Failed to install sound.  Terminating program.\n");
			allegro_message("REPORT:  %s\n", allegro_error);
			exit(0);
		}		
	}
	//debug("Install sound successful!");

	

	// Install Time Handler
	install_int_ex(TIMER_PROC, BPS_TO_TIMER(60));
	install_int_ex(GAME_TIMER_PROC, MSEC_TO_TIMER(1));
	LOCK_VARIABLE(timer);
	LOCK_VARIABLE(system_timer);
	LOCK_FUNCTION(TIMER_PROC);	
	LOCK_FUNCTION(GAME_TIMER_PROC);
	
}

END_OF_MAIN();