#include "comerr.h"
#include "allegro.h"
#include "allegro_color.h"
#include "allegro_keyboard.h"

/*	PURPOSE:  HANDLE MENU PROBLEMS
	PARAMETERS:  iMin - MINIMUM NUMBER FOR MENU CHOICE
				 iMax - MAXIMUM NUMBER FOR MENU CHOICE
	RETURN:  WHETHER SUCCESSFUL OR NOT		*/
short shGet_Menu_Choice(int iMin, int iMax)
{
	char cBuffer[80];							/*HOLD USER'S INPUT 							*/
	short c = 0;								/*VALUE OF WHAT USER KEYED IN					*/ 

	printf("Select a number <%d to %d>: ", iMin, iMax);

	fgets(cBuffer, 81, stdin);	
	/*  If a menu is stuck upon itself, this is the method used to get out. */
	if(strcmp(cBuffer, "exit\n") == 0)
		exit(0);

	c = atoi(cBuffer);	
	
	if(iMin == 0)								/*IF PROGRAMMER WRITES CODE INCORRECTLY*/
	{
		printf("Error to programmer:  iMin cannot equal zero\n");
		return iMax + 1;
	}
	
	if(c >= iMin && c <= iMax )
		return c;
	else if(c == 0)
		printf("\n\nError:  Typed a character.\n");
	else
		printf("\n\nError:  Typed a value that is out of range of menu choice.\n");

	printf("Invalid selection:  Type integer value <%d to %d>\n", iMin, iMax);
	return iMax + 1;	
	
}

/*  PURPOSE:  CHECK IF FILE OPENED WITHOUT ERRORS
	PARAMETERS:  cFile_Path_Name - FILE PATH TO SOURCE FILE
				 Access - HOW THE FILE IS OPENED (R, W, A)
	RETURN:  FILE OPENED OR NULL							
	NOTE:  WROTE THIS FUNCTION FOR HOMEWORK ASSIGNMENT 2 */
FILE *fpFile_Open(char *cFile_Path_Name, char *Access)
{
	FILE *fpFile_Check;							/*FILE POINTER TO CHECK WITH					*/	
	
	fpFile_Check = fopen(cFile_Path_Name, Access);
	if(fpFile_Check == NULL)
	{
		printf("ERROR:  Failure in accessing file.\n");	
		return NULL;
	}

	return fpFile_Check;
}

/*  PURPOSE:  CHECK A POINTER TO SEE IF THERE WAS AN ERROR IN ACCESSING MEMORY
    PARAMETERS: *Pointer - A POINTER THAT IS FREE TO BE ANYTHING
	RETURN:  FALSE IF ERROR, TRUE IF SUCCESSFUL									*/
int iValid_Test(void *Pointer)
{	
	if(Pointer == NULL)									/*TEST TO SEE IF MEMORY AVAILABLE		*/
	{
		printf("ERROR:  Failure in memory access.\n");
		return false;
	}

	return true;
}

char *Read_Line(FILE *finput)
{
	char *ctext, ch;
	int cindex = 0;

	// Get Actual Dialogue 
	ch = fgetc(finput);
	//ctext = (char *) malloc(4 * sizeof(char));
	ctext = new char[20];
	strcpy(ctext, "");
	cindex = 0;
	
	while(ch != '\n' && ch != EOF)
	{			
		if(cindex % 15 == 0)
			ctext = (char *) realloc(ctext, (cindex + 16) * sizeof(char));
		ctext[cindex++] = ch;
		ch = fgetc(finput);
	}
	ctext[cindex] = '\0';

	if(ch == EOF && cindex == 0)
		return NULL;

	return ctext;
}
