#include "allegro.h"
#include "allegro_color.h"
#include "dialogue.h"
#include<string.h>

DIALOGUE::DIALOGUE()
{
	x = 0;
	y = 0;
	width = 0;
	height = 0;	
	bBox = NULL;
	open_state = false;
}

DIALOGUE::~DIALOGUE()
{
}

void DIALOGUE::open()
{
	if(open_state != true)
	{		
		x = 0;
		y = 300;
		width = 640;
		height = 100;
		bBox = create_bitmap(width, height);
		clear(bBox);
		rectfill(bBox, 0, 0, width, height, CORNFLOWERBLUE);
		rect(bBox, 2, 2, width - 2, height - 2, DARKSLATEBLUE);
		rect(bBox, 1, 1, width - 1, height - 1, GREY);
		rect(bBox, 0, 0, width, height, WHITE);				
		open_state = true;
	}
}

void DIALOGUE::open(int x1, int y1, int x2, int y2)
{
	if(open_state != true)
	{
		x = x1;
		y = y1;
		width = x2;
		height = y2;
		bBox = create_bitmap(width, height);
		clear(bBox);
		rectfill(bBox, 0, 0, width, height, CORNFLOWERBLUE);
		rect(bBox, 2, 2, width - 2, height - 2, DARKSLATEBLUE);
		rect(bBox, 1, 1, width - 1, height - 1, GREY);
		rect(bBox, 0, 0, width, height, WHITE);				
		open_state = true;
	}
	
}
void DIALOGUE::close()
{
	if(open_state == true)
	{
		clear(bBox);
		destroy_bitmap(bBox);
		open_state = false;
	}
}


void DIALOGUE::text_output(char *cText)
{
	int i = 0, j = 1;
	BITMAP *bLoad_Text;
	char *cOutput;

	
	cOutput = (char *) malloc((strlen(cText) + 1) * sizeof(char));
	strcpy(cOutput, cText);
	
	bLoad_Text = create_bitmap(bBox->w, bBox->h);
	rectfill(bLoad_Text, 0, 0, bBox->w, bBox->h, MASK);
	
	if(strlen(cOutput) < 78)
		textprintf(bLoad_Text, font, 8, j * 8, WHITE, "%s", cOutput);
	else
	{
		i = 78;		
		while(strlen(cOutput) >= 78)
		{
			while(i > 0 && cOutput[i--] != ' '){}
			cOutput[++i] = '\0';
			textprintf(bLoad_Text, font, 8, j * 8, WHITE, "%s", cOutput);
			cOutput += ++i;
			j++;
		}		
		textprintf(bLoad_Text, font, 8, j * 8, WHITE, "%s", cOutput);
	}
	masked_blit(bLoad_Text, bBox, 0, 0, 0, 0, bLoad_Text->w, bLoad_Text->h);
	destroy_bitmap(bLoad_Text);
//	free(cOutput);
}
