#include "allegro_keyboard.h"
#include "level.h"
#include "enemy.h"
#include "object.h"
#include "game.h"
#include "randomize.h"
#include<stdio.h>
#include<string.h>
#include<math.h>


LEVEL::LEVEL()
{
	cx = 0;
	cy = 0;
	cx_offset = 0;
	cy_offset = 0;
	fLevel = NULL;
	objects = NULL;
	enemies = NULL;
	MapX = 0;
	MapY = 0;
	move_timer = 0;
	targeted = false;
	input_control = true;
	bDisplay = NULL;
	bTop = NULL;
	bMap = NULL;
	finish = false;

	// Initialize Map variables
	for(int i = 0; i < MAP_WIDTH; i++)
		for(int j = 0; j < MAP_HEIGHT; j++)
			Map[i][j] = -1;

	enemies = NULL;
	
}

LEVEL::~LEVEL()
{
}

void LEVEL::load()
{
	char cData[200], cBuffer[201];
	int bx = 0, by = 0, iData = 0, iTemp = 0;
	LIST *ltemp;	
	BITMAP *bTemp;
	OBJECT *oTemp;
	ENEMY *eTemp;
	char cTemp[80];
		
	cx_offset = GFX_W / 2;
	cy_offset = GFX_H / 2;
	cx = cx_offset;
	cy = cy_offset;
	user.body = load_bitmap(".//Data//GFX//elf.pcx", NULL);
	bGUI = load_bitmap(".//Data//GFX//wood.pcx", NULL);

	// Initialize Map variables
	for(int i = 0; i < MAP_WIDTH; i++)
		for(int j = 0; j < MAP_HEIGHT; j++)
			Map[i][j] = -1;	

	// Load file data
	fLevel = fopen(cLevel, "r");	
	if(!fLevel)
	{
		allegro_message("Failed to open file:  %s", cLevel);
		exit(0);
	}

	// Setup the tiles...this could be done elsewhere just one time...
	bTile_Map = load_bitmap(".//Data//GFX//tilemap.pcx", NULL);
	for(int i = 0; i < TILE_COUNT; i++)
	{
        bTiles[i] = create_bitmap(TILE_W, TILE_H);
		blit(bTile_Map, bTiles[i], bx, by, 0, 0, TILE_W, TILE_H);
		bx += TILE_W;
		if(bx >= bTile_Map->w)
		{
			bx = 0;
			by += TILE_H;
		}
	}


	
	
		for(int i = 0; i < 4; i++)
		{
			fscanf(fLevel, "%s", grid[i].cLevel);
			fscanf(fLevel, "%d", &grid[i].x);
			fscanf(fLevel, "%d", &grid[i].y);			
		}
	
		fscanf(fLevel, "%s", cTemp);				
		load_map(cTemp);
		
		// Objects
		fscanf(fLevel, "%d", &iTemp);		
		objects = NULL;
		for(i = 0; i < iTemp; i++)
		{
			oTemp = new OBJECT;
			fscanf(fLevel, "%d", &iData);
			oTemp->x = iData * TILE_W;
			fscanf(fLevel, "%d", &iData);
			oTemp->y = iData * TILE_H;
			fscanf(fLevel, "%d", &iData);
			oTemp->bData = create_bitmap(TILE_W, TILE_H);
			clear(oTemp->bData);
			blit(bTiles[iData], oTemp->bData, 0, 0, 0, 0, TILE_W, TILE_H);
			fscanf(fLevel, "%d", &oTemp->move_speed);
			fscanf(fLevel, "%s", cTemp);
			if(strcmp(cTemp, "true") == 0)
				oTemp->endless_roll = true;
			else
				oTemp->endless_roll = false;
			
			ltemp = Create_List();
			ltemp->data = oTemp;
			objects = Add_List(objects, ltemp);
		}
		
		// AI
		fscanf(fLevel, "%d", &iTemp);		
		enemies = NULL;
		for(i = 0; i < iTemp; i++)
		{
			eTemp = new ENEMY;
			eTemp->body = load_bitmap(".//Data//GFX//elf.pcx", NULL);	
			fscanf(fLevel, "%s", cTemp);
			if(strcmp(cTemp, "HUNT") == 0)	{eTemp->type = HUNT; eTemp->sprite_x=1; eTemp->sprite_y=0;}
			else if(strcmp(cTemp, "RANDOM") == 0)	{eTemp->type = RANDOM;eTemp->sprite_x=1; eTemp->sprite_y=0;}
			else if(strcmp(cTemp, "TEMP") == 0)	{eTemp->type = TEMP;eTemp->sprite_x=1; eTemp->sprite_y=0;}
			else if(strcmp(cTemp, "FROZEN") == 0)	{eTemp->type = FROZEN;eTemp->sprite_x=1; eTemp->sprite_y=0;}
			else if(strcmp(cTemp, "BOUNCE_HORIZONTAL") == 0)	{eTemp->type = BOUNCE_HORIZONTAL;eTemp->sprite_x=1; eTemp->sprite_y=0;}
			else if(strcmp(cTemp, "BOUNCE_VERTICAL") == 0)	{eTemp->type = BOUNCE_VERTICAL;eTemp->sprite_x=1; eTemp->sprite_y=0;}
			else if(strcmp(cTemp, "WALL_LEFT") == 0)	{eTemp->type = WALL_LEFT;eTemp->sprite_x=1; eTemp->sprite_y=0;}
			else if(strcmp(cTemp, "WALL_RIGHT") == 0)	{eTemp->type = WALL_RIGHT;eTemp->sprite_x=1; eTemp->sprite_y=0;}
			else if(strcmp(cTemp, "ARCHER") == 0)	{eTemp->type = ARCHER;eTemp->sprite_x=1; eTemp->sprite_y=1;eTemp->direction = SOUTH;}
			else if(strcmp(cTemp, "RAM") == 0)	{eTemp->type = RAM;eTemp->sprite_x=0; eTemp->sprite_y=1;eTemp->direction = SOUTH;eTemp->validate_animate();eTemp->direction = NONE;}
			fscanf(fLevel, "%d", &iData);
			eTemp->ex = iData * TILE_W;
			fscanf(fLevel, "%d", &iData);
			eTemp->ey = iData * TILE_H;
			fscanf(fLevel, "%d", &iData);
			if(iData == 1)
				eTemp->good = true;
			else
				eTemp->good = false;
			
			fscanf(fLevel, "%d", &eTemp->move_speed);
			fscanf(fLevel, "%d", &eTemp->animate_speed);			
			
			eTemp->cText = (char **) malloc(2 * sizeof(char *));
			eTemp->cText[0] = (char *) malloc(200 * sizeof(char));
			eTemp->cText[1] = NULL;			
			
			fscanf(fLevel, "%s", eTemp->cText);

			ltemp = Create_List();
			ltemp->data = eTemp;
			enemies = Add_List(enemies, ltemp);
			

		}

		
		
			
				

	
	/*
	// Load the objects
	ltemp = Create_List();
	oTemp = new OBJECT;
	oTemp->x = 10 * TILE_W;
	oTemp->y = 10 * TILE_H;
	oTemp->item_x = 0;
	oTemp->item_y = TILE_H * 1;
	oTemp->move_speed = 20;
	oTemp->bData = load_bitmap(".//Data//GFX//tilemap.bmp", NULL);

	ltemp->data = oTemp;	
	objects = Add_List(objects, ltemp);

	ltemp = Create_List();
	oTemp = new OBJECT;
	oTemp->x = 12 * TILE_W;
	oTemp->y = 10 * TILE_H;
	oTemp->item_x = 0;
	oTemp->item_y = TILE_H * 2;
	oTemp->move_speed = 10;
	oTemp->endless_roll = true;
	oTemp->bData = load_bitmap(".//Data//GFX//tilemap.bmp", NULL);
	ltemp->data = oTemp;	
	objects = Add_List(objects, ltemp);

	
	// Load the enemies (currently manual load)
	ltemp = Create_List();
	AI = new ENEMY;
	AI->type = RAM;
	AI->ex = 150;
	AI->ey = 150;
	AI->sprite_x = 1;
	AI->sprite_y = 0;
	AI->good = true;
	AI->move_speed = 5;
	AI->animate_speed = 100;
	AI->body = load_bitmap(".//Data//GFX//elf.bmp", NULL);	
	AI->cText = (char **) malloc(10 * sizeof(char *));
	AI->cText[0] = (char *) malloc(1330 * sizeof(char));
	AI->cText[1] = NULL;
	strcpy(AI->cText[0], "I was thinking of Brittainy, but she didn't show, I wish she'd come here an give me a blow! I was thinking of Brittainy, but she didn't show, I wish she'd come here an give me a blow! I was thinking of Brittainy, but she didn't show, I wish she'd come here an give me a blow!");

	ltemp->data = AI;	
	enemies = Add_List(enemies, ltemp);

	ltemp = Create_List();
	AI = new ENEMY;
	AI->type = BOUNCE_HORIZONTAL;
	AI->ex = 200;
	AI->ey = 200;
	AI->sprite_x = 1;
	AI->sprite_y = 0;
	AI->move_speed = 30;
	AI->animate_speed = 130;
	AI->body = load_bitmap(".//Data//GFX//elf.bmp", NULL);	
	ltemp->data = AI;	
	enemies = Add_List(enemies, ltemp);

	ltemp = Create_List();
	AI = new ENEMY;
	AI->type = BOUNCE_VERTICAL;
	AI->ex = 300;
	AI->ey = 100;
	AI->sprite_x = 1;
	AI->sprite_y = 0;
	AI->move_speed = 30;
	AI->animate_speed = 130;
	AI->body = load_bitmap(".//Data//GFX//elf.bmp", NULL);	
	ltemp->data = AI;	
	enemies = Add_List(enemies, ltemp);

	ltemp = Create_List();
	AI = new ENEMY;
	AI->type = HUNT;
	AI->ex = 200;
	AI->ey = 400;
	AI->move_speed = 30;
	AI->animate_speed = 30;
	AI->sprite_x = 1;
	AI->sprite_y = 0;
	AI->body = load_bitmap(".//Data//GFX//elf.bmp", NULL);	
	ltemp->data = AI;	
	enemies = Add_List(enemies, ltemp);

	ltemp = Create_List();
	AI = new ENEMY;
	AI->type = RAM;
	AI->ex = 200;
	AI->ey = 500;
	AI->sprite_x = 1;
	AI->sprite_y = 0;
	AI->move_speed = 30;
	AI->animate_speed = 310;
	AI->body = load_bitmap(".//Data//GFX//elf.bmp", NULL);	
	ltemp->data = AI;	
	enemies = Add_List(enemies, ltemp);

	ltemp = Create_List();
	AI = new ENEMY;
	AI->type = RAM;
	AI->ex = 300;
	AI->ey = 300;
	AI->sprite_x = 1;
	AI->sprite_y = 0;
	AI->move_speed = 30;
	AI->animate_speed = 130;
	AI->body = load_bitmap(".//Data//GFX//elf.bmp", NULL);	
	ltemp->data = AI;	
	enemies = Add_List(enemies, ltemp);

	ltemp = Create_List();
	AI = new ENEMY;
	AI->type = RAM;
	AI->ex = 800;
	AI->ey = 600;
	AI->sprite_x = 1;
	AI->sprite_y = 0;
	AI->move_speed = 22;
	AI->animate_speed = 120;
	AI->body = load_bitmap(".//Data//GFX//elf.bmp", NULL);	
	ltemp->data = AI;	
	enemies = Add_List(enemies, ltemp);

	ltemp = Create_List();
	AI = new ENEMY;
	AI->type = RAM;
	AI->ex = 320;
	AI->ey = 200;
	AI->sprite_x = 1;
	AI->sprite_y = 0;
	AI->move_speed = 520;
	AI->animate_speed = 130;
	AI->body = load_bitmap(".//Data//GFX//elf.bmp", NULL);	
	ltemp->data = AI;
	enemies = Add_List(enemies, ltemp);

	ltemp = Create_List();
	AI = new ENEMY;
	AI->type = HUNT;
	AI->ex = 320;
	AI->ey = 820;
	AI->sprite_x = 1;
	AI->sprite_y = 0;
	AI->move_speed = 120;
	AI->animate_speed = 130;
	AI->body = load_bitmap(".//Data//GFX//elf.bmp", NULL);	
	ltemp->data = AI;
	enemies = Add_List(enemies, ltemp);
	*/
	
}

void LEVEL::load_map(char *cTemp)
{
		char cData[200], cBuffer[201];
	int i = 0, j = 0, bx = 0, by = 0, iData = 0;
	LIST *ltemp;	
	BITMAP *bTemp;
	OBJECT *oTemp;
	FILE *fMap;

	fMap = fopen(cTemp, "r");
	if(fMap == NULL)
	{
		allegro_message("Failed to open map:  %s", cTemp);
		exit(0);
	}

	while(fgets(cBuffer, 200, fMap) != NULL)
	{
		//parse string
		j = 0;
		i = 0;		
		MapX = 0;
		while(cBuffer[i] != '\0' && cBuffer[i] != '\n')
		{			
			if(cBuffer[i] == ' ')
			{
				cData[j] = '\0';
				if(strcmp(cData, "") != 0)
				{					
					iData = atoi(cData);					
					Map[MapX++][MapY] = iData;
				}
				j = 0;
			}
			else
				cData[j++] = cBuffer[i];			
			i++;
		}
		if(cBuffer[i] == '\n' || cBuffer[i] == '\0')
		{
			cData[j] = '\0';
			if(strcmp(cData, "") != 0)
			{					
				iData = atoi(cData);					
				Map[MapX++][MapY] = iData;
			}
		}
		MapY++;	
	}
	fclose(fMap);

	//Stretch Map
	bMap = create_bitmap(80, 80);
	bTemp = create_bitmap(MapX, MapY);	
	clear(bMap);
	for(int y = 0; y < MapY; y++)
	{
		for(int x = 0; x < MapX; x++)
		{
			iData = Map[x][y];
			switch(iData)
			{
			case 1:
				putpixel(bTemp, x, y, DARKGREEN);
				break;
			case 2:
				putpixel(bTemp, x, y, BLUE);
				break;
			case 3:
				putpixel(bTemp, x, y, WHITE);
				break;
			case 4:
				putpixel(bTemp, x, y, BROWN);
				break;
			default:
				putpixel(bTemp, x, y, GREEN);
				break;
			}
		}
	}	
			
	
	stretch_blit(bTemp, bMap, 0, 0, bTemp->w, bTemp->h, 0, 0, bMap->w, bMap->h);	
}

void LEVEL::play()
{	
		
	bBuffer = create_bitmap(GFX_W, GFX_H);
	bDisplay = create_sub_bitmap(bBuffer, 0, 0, 640, 400);	
	bTop = create_bitmap(640, 400);	
	
	
	// Main Loop!
	move_timer = system_timer;
	finish = false;
	
	while(!key[KEY_ESC] && !finish)
	{		
		if(user.alive == true) input();
		AI_Process();
		Object_Process();
		draw();		
	}	

	for(int i = 0; i < TILE_COUNT; i++)
		destroy_bitmap(bTiles[i]);
	destroy_bitmap(bTile_Map);
	destroy_bitmap(bDisplay);	
	destroy_bitmap(bTop);
	destroy_bitmap(bMap);
	destroy_bitmap(bBuffer);
	destroy_bitmap(user.body);

}

void LEVEL::destroy()
{
	//Destroy_List(objects);
	//Destroy_List(enemies);
}

void LEVEL::Object_Process()
{
	LIST *traverse = objects;
	OBJECT *oTemp;
	int save_x = 0, save_y = 0;

	while(traverse != NULL)
	{
		oTemp = (OBJECT *) traverse->data;
		save_x = oTemp->x / TILE_W;
		save_y = oTemp->y / TILE_H;
		oTemp->action();

		if(collision(oTemp, (save_x * TILE_W) + 16, oTemp->y) == true)
		{
			if(oTemp->endless_roll == true)
			{
				oTemp->direction = NONE;
				oTemp->steps = 0;
			}
			oTemp->y = save_y * TILE_H;
		}
		if(collision(oTemp, oTemp->x + 16, save_y * TILE_H) == true)
		{
			if(oTemp->endless_roll == true)
			{
				oTemp->direction = NONE;
				oTemp->steps = 0;
			}
			oTemp->x = save_x * TILE_W;
		}

		traverse = traverse->next;
	}
	
}

void LEVEL::AI_Process()
{
	LIST *traverse = enemies;
	ENEMY *eTemp;
	int dir = 0, save_x = 0, save_y = 0;
	
	while(traverse != NULL)
	{
		eTemp = (ENEMY *) traverse->data;

		save_x = eTemp->ex;
		save_y = eTemp->ey;
		
		if(targeted == true)
			eTemp->action(user.px, user.py, false);
		else
			eTemp->action(user.px, user.py, true);

		// Make sure AI hasn't moved into a filled tiled
		// Also, if we did hit something, see if it was the player (and not another enemy)
		if(collision(eTemp, save_x, eTemp->ey) == true)
		{
			if(user.touched == true)
			{
				if(eTemp->good == false)
					user.die();
				else
					user.touched = false;
			}

			eTemp->ey = save_y;
			if(eTemp->type == BOUNCE_VERTICAL)
				eTemp->pick_vertical();
			if(eTemp->type == RAM)
				eTemp->direction = NONE;
		}
		if(collision(eTemp, eTemp->ex, save_y) == true)
		{
			if(user.touched == true)
			{
				if(eTemp->good == false)
					user.die();
				else
					user.touched = false;
			}
			eTemp->ex = save_x;	

			if(eTemp->type == BOUNCE_HORIZONTAL)
				eTemp->pick_horizontal();
			if(eTemp->type == RAM)
				eTemp->direction = NONE;

		}



		traverse->ikey = eTemp->ey;
		traverse = traverse->next;
	}
	enemies = Sort_List(enemies);
	
}

void LEVEL::input()
{
	int save_x = 0, save_y = 0, height = TILE_H * 2;
	if(user.movement_ok())
	{
		
		save_x = user.px;
		save_y = user.py;
		user.direction = NONE;

		// KEYS
		if(input_control == true)
		{
			if(key[KEY_RIGHT] && user.px < MapX * TILE_W + TILE_W)
			{
				user.frame_y = height * 3 + (user.sprite_y * (6 * TILE_H));
				user.direction = EAST;
				user.px += 5;
				
			}
			if(key[KEY_LEFT] && user.px >= 0)
			{
				user.frame_y = height * 1 + (user.sprite_y * (6 * TILE_H));
				user.direction = WEST;			
				user.px -= 5;
			}
			if(key[KEY_DOWN] && user.py < MapY * TILE_H + TILE_H)
			{
				user.frame_y = height * 0 + (user.sprite_y * (6 * TILE_H));
				user.direction = SOUTH;
				user.py += 5;
			}
			if(key[KEY_UP] && user.py >= 0)
			{
				user.frame_y = height * 2 + (user.sprite_y * (6 * TILE_H));
				user.direction = NORTH;
				user.py -= 5;
			}
		}

		// Accept routines
		if(key[KEY_SPACE] || key[KEY_ENTER])
		{
			if(targeted == false)
			    accept();
			else
				decline();
		}

		
		if(collision(&user, save_x, user.py) == true)
			user.py = save_y;
		if(collision(&user, user.px, save_y) == true)
			user.px = save_x;

		// See if moved into enemies path
		enemy_path();

		
		//Update the camera position based on the user's position
		if(user.py >= GFX_H / 2 && user.py < (MapY * TILE_H) - (GFX_H / 2) + 80 )
			cy = user.py;
		if(user.px >= GFX_W / 2 && user.px < (MapX * TILE_W) - (GFX_W / 2))
			cx = user.px;
		move_timer = system_timer;
	}	
}

bool LEVEL::collision(void *unit, int x, int y)
{
	LIST *traverse = enemies;
	ENEMY *eTemp;
	OBJECT *oTemp;

	//possibly go to a new level
	if(x < TILE_W || x > MapX * TILE_W || y < TILE_H || y > MapY * TILE_H + TILE_H)
	{
		
		//did this in last 30 mins of CH!!!!
		/*if(y < TILE_H && strcmp(grid[0].cLevel, "NONE") != 0)
		{
			clear(screen);
			finish = true;
			strcpy(cLevel, grid[0].cLevel);
			//user.px = grid[0].x;
			//user.py = grid[0].y;
		}*/				
		return true;
	}
	
	if(Map[(x - 16)  / TILE_W][y / TILE_H] != 2 &&  Map[(x - 16)  / TILE_W][y / TILE_H] > 3)
		return true;
	
	// Something ran into the player!
	if(unit != &user && 
		((x - 16) / TILE_W) == ((user.px - 16) / TILE_W) && 
		(y / TILE_H) == (user.py / TILE_H))
	{
		user.touched = true;		
		return true;
	}
	
	// Ran into an enemy
	while(traverse != NULL)
	{
		eTemp = (ENEMY *) traverse->data;
		if(eTemp != unit && 
			((x - 16) / TILE_W) == ((eTemp->ex - 16) / TILE_W) && 
			(y / TILE_H) == ((eTemp->ey) / TILE_H))
			return true;
			
		traverse = traverse->next;
	}

	//Ran into an object
	traverse = objects;
	while(traverse != NULL)
	{
		oTemp = (OBJECT *) traverse->data;
		if( oTemp != unit && 
			((x - 16) / TILE_W) == ((oTemp->x) / TILE_W) && 
			(y / TILE_H) == ((oTemp->y) / TILE_H))		
			return true;
		traverse = traverse->next;
	}

	return false;
}

void LEVEL::enemy_path()
{
	LIST *traverse = enemies;
	ENEMY *eTemp;

	while(traverse != NULL)
	{
		eTemp = (ENEMY *) traverse->data;
		if(eTemp->type == ARCHER && 
				(((eTemp->ex - 16) / TILE_W) == ((user.px - 16) / TILE_W) || 
			(eTemp->ey / TILE_H) == (user.py / TILE_H)))
				straight_shot(eTemp);
		if(eTemp->type == RAM && eTemp->direction == NONE && 
				(((eTemp->ex - 16) / TILE_W) == ((user.px - 16) / TILE_W) || 
			(eTemp->ey / TILE_H) == (user.py / TILE_H)))
				pick_direction(eTemp);
		
		traverse = traverse->next;
	}		
		
}

void LEVEL::pick_direction(ENEMY *eTemp)
{
	if(((eTemp->ex - 16) / TILE_W) == ((user.px - 16) / TILE_W))
	{
		if(user.py >= eTemp->ey)
			eTemp->direction = SOUTH;
		else
			eTemp->direction = NORTH;
	}
	if((eTemp->ey / TILE_H) == (user.py / TILE_H))
	{			
		if(user.px >= eTemp->ex)
			eTemp->direction = EAST;
		else
			eTemp->direction = WEST;
	}		
}

void LEVEL::straight_shot(ENEMY *eTemp)
{
	int iFind = 0;
	bool failed = true;	

	if(((eTemp->ex - 16) / TILE_W) == ((user.px - 16) / TILE_W))
	{		
		failed = false;
		if(user.py >= eTemp->ey)
		{
			iFind = user.py - TILE_H;						
			while(iFind > 0 && iFind >= eTemp->ey + 16)
			{
				if(collision(&user, eTemp->ex, iFind) == true)				
					failed = true;
				iFind -= TILE_H;
			}			
		}
		else
		{			
			iFind = user.py + TILE_H + 8;			
			while(iFind / TILE_H < MapY && iFind < eTemp->ey - 16)
			{
				if(collision(&user, eTemp->ex, iFind) == true)				
					failed = true;
				iFind += TILE_H;
			}
		}		
	}
	if((eTemp->ey / TILE_H) == (user.py / TILE_H))
	{		
		failed = false;
		if(user.px >= eTemp->ex)
		{				
			iFind = user.px - TILE_W - 8;						
			while(iFind > 0 && iFind >= eTemp->ex + 16)
			{					
				if(collision(&user, iFind, eTemp->ey) == true)				
					failed = true;
				iFind -= TILE_W;
			}			
		}
		else
		{			
			iFind = user.px + TILE_W;			
			while(iFind / TILE_W < MapX && iFind < eTemp->ex - 16)
			{
				if(collision(&user, iFind, eTemp->ey) == true)				
					failed = true;
				iFind += TILE_W;
			}
			
		}
	}
	if(failed == false)
	{
		
		eTemp->type = FROZEN;
		eTemp->frame_x = (TILE_W * 3)  + (eTemp->sprite_x * (4 * TILE_W));
		eTemp->frame_y = (TILE_H * 2) * 2 + (eTemp->sprite_y * (6 * TILE_H));
		user.die();
	}
	
}

void LEVEL::draw()
{
	int pos_x = 0, pos_y = 0;
	LIST *traverse;
	ENEMY *eTemp;
	OBJECT *oTemp;
	bool elf_drawn = false;

	
	//Draw the Tiles
	clear(bDisplay);
	clear(bTop);

	//if(strcmp(cLevel, ".//Data//Levels//level1.txt") != 0)
		//allegro_message("%s", cLevel);
	
	
	rectfill(bTop, 0, 0, bTop->w, bTop->h, MASK);
	for(int y = 0; y < MAP_HEIGHT; y++)
	{			
		for(int x = 0; x < MAP_WIDTH; x++)
		{				
			pos_x = (x * TILE_W) - (cx - cx_offset);
			pos_y = (y * TILE_H) - (cy - cy_offset);
			if(x >= 0 && x < MAP_WIDTH && y >= 0 && y < MAP_HEIGHT && Map[x][y] >= 0)
			{
				if(pos_x >= 0 - TILE_W && pos_x < GFX_W && pos_y >= 0 - TILE_H && pos_y < GFX_H)
				{
				switch(Map[x][y])
				{
				case 1: //Grass
					masked_blit(bTiles[0], bDisplay, 0, 0, pos_x, pos_y, TILE_W, TILE_H);
					masked_blit(bTiles[12], bDisplay, 0, 0, pos_x, pos_y, TILE_W, TILE_H);
					dynamic_tiles(x, y, pos_x, pos_y, 12, 1);										
					break;
				case 2: //Water
					masked_blit(bTiles[0], bDisplay, 0, 0, pos_x, pos_y, TILE_W, TILE_H);
					masked_blit(bTiles[16], bDisplay, 0, 0, pos_x, pos_y, TILE_W, TILE_H);
					dynamic_tiles(x, y, pos_x, pos_y, 16, 2);					
					break;
				case 3:  //Snow
					masked_blit(bTiles[0], bDisplay, 0, 0, pos_x, pos_y, TILE_W, TILE_H);
					masked_blit(bTiles[42], bDisplay, 0, 0, pos_x, pos_y, TILE_W, TILE_H);
					dynamic_tiles(x, y, pos_x, pos_y, 42, 3);					
					break;
				case 4:  //Grass Tree
					masked_blit(bTiles[0], bDisplay, 0, 0, pos_x, pos_y, TILE_W, TILE_H);
					masked_blit(bTiles[29], bDisplay, 0, 0, pos_x, pos_y, TILE_W, TILE_H);					
					if(y - 1 >= 0)
					{
						pos_y = ((y - 1) * TILE_H) - (cy - cy_offset);
						masked_blit(bTiles[19], bTop, 0, 0, pos_x, pos_y, TILE_W, TILE_H);					
					}
					if(y - 2 >= 0)
					{
						pos_y = ((y - 2) * TILE_H) - (cy - cy_offset);
						masked_blit(bTiles[9], bTop, 0, 0, pos_x, pos_y, TILE_W, TILE_H);					
					}
			
					break;
					
				
				default:					
						masked_blit(bTiles[Map[x][y]], bDisplay, 0, 0, pos_x, pos_y, TILE_W, TILE_H);
						
				}
				}
			}
		}
	}		
	
	//Update Elf's animation frame
	user.validate_animate();

	//Draw objects
	traverse = objects;
	while(traverse != NULL)
	{
		oTemp = (OBJECT *) traverse->data;
		pos_x = oTemp->x - (cx - cx_offset);
		pos_y = oTemp->y - (cy - cy_offset);		
		masked_blit(oTemp->bData, bDisplay, oTemp->item_x, oTemp->item_y, pos_x, pos_y, TILE_W, TILE_H);					
		traverse = traverse->next;
	}
	
	//Draw the AI
	traverse = enemies;
	while(traverse != NULL)
	{
		eTemp = (ENEMY *) traverse->data;		
		
		//Draw the Elf
		if(user.py < eTemp->ey && elf_drawn == false)
		{
			pos_y = user.py - (cy - cy_offset) - (TILE_H * 2);
			pos_x = user.px - (cx - cx_offset) - TILE_W;			
			masked_blit(user.body, bDisplay, user.frame_x, user.frame_y, pos_x, pos_y, TILE_W, TILE_H * 2);
			elf_drawn = true;	
		}		
				
		pos_y = eTemp->ey - (cy - cy_offset) - (TILE_H * 2);
		pos_x = eTemp->ex - (cx - cx_offset) - TILE_W;		
		masked_blit(eTemp->body, bDisplay, eTemp->frame_x, eTemp->frame_y, pos_x, pos_y, TILE_W, TILE_H * 2);	

		traverse = traverse->next;		
	}
	
	//Draw the Elf
	if(elf_drawn == false)
	{
		pos_y = user.py - (cy - cy_offset) - (TILE_H * 2);
		pos_x = user.px - (cx - cx_offset) - TILE_W;
		masked_blit(user.body, bDisplay, user.frame_x, user.frame_y, pos_x, pos_y, TILE_W, TILE_H * 2);	
	}			
	draw_sprite(bBuffer, bTop, 0, 0);
	
	// Last thing to draw, the dialogue box (if open)
	draw_window();

	// Draw on the GUI
	masked_blit(bMap, bGUI, 0, 0, 500, 5, 80, 80);

	draw_sprite(bBuffer, bGUI, 0, 400);	
	draw_sprite(screen, bBuffer, 0, 0);	
}

// Just pumpin' this out, could be cleaned up quite a bit, but is a low-priority method
void LEVEL::dynamic_tiles(int x, int y, int pos_x, int pos_y, int reference_frame, int case_number)
{	
	if(x > 0 && x < MAP_WIDTH - 1 && y > 0 && y < MAP_HEIGHT - 1 &&
		Map[x-1][y] == case_number && Map[x+1][y] == case_number && Map[x][y-1] == case_number && Map[x][y+1] == case_number)
        masked_blit(bTiles[reference_frame - 8], bDisplay, 0, 0, pos_x, pos_y, TILE_W, TILE_H);
	else
	{
		if(x > 0 && y < MAP_HEIGHT - 1 && Map[x-1][y+1] == case_number)
			masked_blit(bTiles[reference_frame-9], bDisplay, 0, 0, pos_x, pos_y, TILE_W, TILE_H);
		if(y < MAP_HEIGHT - 1 && Map[x][y+1] == case_number)
			masked_blit(bTiles[reference_frame-10], bDisplay, 0, 0, pos_x, pos_y, TILE_W, TILE_H);
		if(x < MAP_WIDTH - 1 && y < MAP_HEIGHT - 1 && Map[x+1][y+1] == case_number)
			masked_blit(bTiles[reference_frame-11], bDisplay, 0, 0, pos_x, pos_y, TILE_W, TILE_H);
		
		if(x < MAP_WIDTH - 1 && Map[x+1][y] == case_number)
			masked_blit(bTiles[reference_frame-1], bDisplay, 0, 0, pos_x, pos_y, TILE_W, TILE_H);
		if(x > 0 && Map[x-1][y] == case_number)
			masked_blit(bTiles[reference_frame+1], bDisplay, 0, 0, pos_x, pos_y, TILE_W, TILE_H);
		
		if(x > 0 && y > 0 && Map[x-1][y-1] == case_number)
			masked_blit(bTiles[reference_frame+11], bDisplay, 0, 0, pos_x, pos_y, TILE_W, TILE_H);
		if(x < MAP_WIDTH - 1 && y > 0 && Map[x+1][y-1] == case_number)
			masked_blit(bTiles[reference_frame+9], bDisplay, 0, 0, pos_x, pos_y, TILE_W, TILE_H);
		if(y > 0 && Map[x][y-1] == case_number)
			masked_blit(bTiles[reference_frame+10], bDisplay, 0, 0, pos_x, pos_y, TILE_W, TILE_H);
		
	}
}

void LEVEL::draw_window()
{
	if(dDisplay.open_state == true)
		masked_blit(dDisplay.bBox, bDisplay, 0, 0, dDisplay.x, dDisplay.y, dDisplay.width, dDisplay.height);

}

void LEVEL::accept()
{
	if(key_pressed(KEY_SPACE))
		talk();	
}

void LEVEL::talk()
{
	LIST *traverse = enemies;
	ENEMY *eTemp;
	OBJECT *oTemp;

	bool quit = false;
	int x = 0, y = 0;

	switch(user.direction)
	{		
	case NORTHEAST:
		x = user.px + 32;
		y = user.py - 16;
		break;
	case NORTHWEST:
		x = user.px;
		y = user.py - 16;
		break;
	case SOUTHEAST:
		x = user.px + 32;
		y = user.py + 16;
		break;
	case SOUTHWEST:
		x = user.px;
		y = user.py + 16;
	case NORTH:
		x = user.px - 16;
		y = user.py - 16;
		break;
	case SOUTH:
		x = user.px - 16;
		y = user.py + 16;
		break;
	case EAST:
		x = user.px;
		y = user.py;
		break;
	case WEST:
		x = user.px - 16;
		y = user.py;
		break;
	}
	traverse = enemies;
	while(traverse != NULL && quit != true)
	{
		eTemp = (ENEMY *) traverse->data;
		if(eTemp->good == true)
		{
			if(((x) / TILE_W) == ((eTemp->ex - 16) / TILE_W) && 
				(y / TILE_H) == ((eTemp->ey) / TILE_H))
			{
				quit = true;
				dDisplay.open();
				dDisplay.text_output(eTemp->cText[0]);
				input_control = false;
				targeted = true;
				eTemp->temp_type = eTemp->type;
				eTemp->type = TEMP;
			}
		}

		traverse = traverse->next;
	}
	traverse = objects;
	while(traverse != NULL && quit != true)
	{
		oTemp = (OBJECT *) traverse->data;
		if(((x) / TILE_W) == ((oTemp->x) / TILE_W) && 
			(y / TILE_H) == ((oTemp->y) / TILE_H))
		{
			quit = true;
			oTemp->direction = user.direction;			
			oTemp->steps = TILE_W / 4;			
		}
		traverse = traverse->next;
	}
}

void LEVEL::decline()
{
	while(key[KEY_SPACE]){}
	
	dDisplay.text_output("");
	dDisplay.close();
	input_control = true;
	targeted = false;	
}
