#ifndef _LEVEL_H_
#define _LEVEL_H_

#include "allegro.h"
#include "allegro_color.h"
#include "list.h"
#include "enemy.h"
#include "player.h"
#include "dialogue.h"
#include "object.h"

#include<stdio.h>

#define MAP_WIDTH 100
#define MAP_HEIGHT 100
#define TILE_COUNT 60
#define TILE_H 32
#define TILE_W 32

typedef class LEVEL level;

typedef struct adjacent
{
	char cLevel[30];
	int x;
	int y;

}ADJACENT;

class LEVEL
{
public:
	ADJACENT grid[3];

	// Map Setup
	int Map[MAP_WIDTH][MAP_HEIGHT];
	BITMAP *bTile_Map;
	BITMAP *bTiles[TILE_COUNT];
	FILE *fLevel;	
	int move_timer;

	// Camera Setup
	int cx;
	int cy;
	int cx_offset;
	int cy_offset;
	int MapX;
	int MapY;

	// Display Setup
	BITMAP *bBuffer;
	BITMAP *bGUI;
	BITMAP *bDisplay;
	BITMAP *bTop;
	BITMAP *bMap;
	DIALOGUE dDisplay;

	PLAYER user;
	LIST *enemies;
	LIST *objects;
	ENEMY *AI;

	// Input Handling
	bool input_control;
	bool targeted;
	bool finish;

	char cLevel[80];

	LEVEL();
	~LEVEL();

	void load();
	void play();
	void AI_Process();
	void Object_Process();
	bool collision(void *unit, int x, int y);
	void enemy_path();
	void straight_shot(ENEMY *eTemp);
	void pick_direction(ENEMY *eTemp);
	void draw();
	void input();
	void talk();
	void accept();
	void decline();
	void destroy();
	void draw_window();
	void dynamic_tiles(int x, int y, int pos_x, int pos_y, int reference_frame, int case_number);
	void load_map(char *cTemp);

};


#endif /* End of _LEVEL_H_ */