#include "player.h"
#include "game.h"

PLAYER::PLAYER()
{
	px = 0;
	py = 0;
	frame_x = 0;
	frame_y = 0;
	move_timer = 0;
	move_speed = 20;
	sprite_x = 0;
	sprite_y = 0;
	blink_timer = 0;
	sleep_timer = 0;
	animate_timer = 0;
	animate_speed = 250;
	animate_positive = 0;
	death_state = 0;
	touched = false;
	alive = true;
	direction = NONE;
}

PLAYER::~PLAYER()
{


}

void PLAYER::validate_animate()
{
	int height = TILE_H * 2;
	bool rest;
	if(direction != DEAD && animate_ok())
	{
		rest = false;		
		switch(direction)
		{
		case NORTHEAST:
		case NORTHWEST:
		case NORTH:
			frame_y = height * 2 + (sprite_y * (6 * TILE_H));
			change_animateX();				
			break;
		case SOUTHEAST:
		case SOUTHWEST:
		case SOUTH:
			frame_y = height * 0 + (sprite_y * (6 * TILE_H));
			change_animateX();		
			break;
		case EAST:
			frame_y = height * 3 + (sprite_y * (6 * TILE_H));
			change_animateX();		
			break;
		case WEST:
			frame_y = height * 1 + (sprite_y * (6 * TILE_H));
			change_animateX();		
			break;
		case NONE:
			sleep_now();
			if(sleep != true)
				frame_x = (TILE_W * 1) + (sprite_x * (4 * TILE_W));		
			else
				change_zzz();
			blink_now();			
			rest = true;
		}
		
		if(rest == false)
		{
			blink_timer = system_timer;
			sleep_timer = system_timer;
			sleep = false;			
		}
	}
	else if(direction == DEAD)
		die();
	
	
	
}

void PLAYER::blink_now()
{
	if(abs(system_timer - blink_timer) > 800 && direction == NONE)
	{		
		frame_x = (TILE_W * 3) + (sprite_x * (4 * TILE_W));		
		blink_timer = system_timer;		
	}
}

void PLAYER::sleep_now()
{
	int height = TILE_H * 2;
	if(abs(system_timer - sleep_timer) > 5000)
	{
		frame_x = (TILE_W * 3) + (sprite_x * (4 * TILE_W));		
		frame_y = height * 4 + (sprite_y * (6 * TILE_H));
		sleep_timer = system_timer;
		sleep = true;
	}
}

void PLAYER::change_zzz()
{
	if(sleep != true)
		return;

	if(animate_sleep == true)
	{
		frame_x = (TILE_W * 2) + (sprite_x * (4 * TILE_W));		
		animate_sleep = false;
	}
	else
	{
		frame_x = (TILE_W * 3) + (sprite_x * (4 * TILE_W));		
		animate_sleep = true;
	}
}


void PLAYER::change_animateX()
{
	if(sleep == true)
		frame_x = (TILE_W * 1) + (sprite_x * (4 * TILE_W));		
			
	if(animate_positive == true)
		frame_x += TILE_W;
	else
		frame_x -= TILE_W;

	if(frame_x >= (TILE_W * 2) + (sprite_x * (4 * TILE_W)))	animate_positive = false;
	if(frame_x <= (TILE_W * 0) + (sprite_x * (4 * TILE_W)))		animate_positive = true;
}

bool PLAYER::movement_ok()
{
	if(abs(system_timer - move_timer) > move_speed)
	{
		move_timer = system_timer;
		return true;
	}
	return false;
}

bool PLAYER::animate_ok()
{
	if(abs(system_timer - animate_timer) > animate_speed)
	{
		animate_timer = system_timer;
		return true;
	}
	return false;
}

void PLAYER::die()
{
	int height = TILE_H * 2;
	alive = false;
	
	if(death_state == 0)
	{
		frame_x = (TILE_W * 1) + (sprite_x * (4 * TILE_W));		
		frame_y = height * 4 + (sprite_y * (6 * TILE_H));	
		direction = DEAD;
	}
	if(abs(system_timer - animate_timer) > 1000)
	{		
		death_state++;
		switch(death_state)
		{
		case 1:
            frame_x = (TILE_W * 1) + (sprite_x * (4 * TILE_W));		
			frame_y = height * 5 + (sprite_y * (6 * TILE_H));
			break;
		case 2:
			frame_x = (TILE_W * 2) + (sprite_x * (4 * TILE_W));		
			frame_y = height * 5 + (sprite_y * (6 * TILE_H));
			break;		
		}
		animate_timer = system_timer;
	}

}