/*----------------------------------- RANDOMIZE.H ----------------------------------------------------
  -  AUTHOR:  Steven P. Silvey																		 -
  -  DATE CREATED:  2/9/2003																		 -
  -  DATE MODIFIED: 2/9/2003																		 -
  -  PURPOSE:  The implementation of the functions used for randomly selected values within a range. -
  ----------------------------------------------------------------------------------------------------*/

#include<stdlib.h>
#include<time.h>

/*  PURPOSE:  Seed the random generator randomly according to the current time
    PARAMETERS:  NONE
	RETURN:	NONE																*/
void SEED()
{
	srand( (unsigned) time(NULL));
}

/*  PURPOSE:  Create a random integer between a selected range.
    PARAMETERS:  range1 - lower bound
				 range2 - upper bound
	RETURN:	 The random number between range1 and range2						*/
int rnd(int range1, int range2)
{
	int rand_range, temp;			

	/*SWAP routine*/
	if(range1 > range2)
	{
		temp = range1;
		range1 = range2;
		range2 = temp;
	}

	rand_range = range1 - 1;	
	
	while(rand_range < range1 || rand_range > range2)
		rand_range = rand();

	return rand_range;
}

/*  PURPOSE:  Create a random integer between 0 and a selected range.
    PARAMETERS:  range1 - upper bound
	RETURN:  The random number between 0 and range1								*/
int rnd(int range1)
{
	int rand_range;	

	rand_range = -1;
	
	while(rand_range < 0 || rand_range > range1)
		rand_range = rand();

	return rand_range;
}	
