/*----------------------------------- RANDOMIZE.H ----------------------------------------------------
  -  AUTHOR:  Steven P. Silvey																		 -
  -  DATE CREATED:  2/6/2003																		 -
  -  DATE MODIFIED: 2/9/2003																		 -
  -  PURPOSE:  Create a new way to select a random number with ease.  Now, I can pick a random number-
  -  in a selected range.																			 -
  ---------------------------------------------------------------------------------------------------*/

#ifndef _RANDOMIZE_H_
#define _RANDOMIZE_H_

//#include "randomize.cpp"

/*  PURPOSE:  Seed the random generator randomly according to the current time
    PARAMETERS:  NONE
	RETURN:	NONE																*/
void SEED();

/*  PURPOSE:  Create a random integer between a selected range.
    PARAMETERS:  range1 - lower bound
				 range2 - upper bound
	RETURN:	 The random number between range1 and range2						*/
int rnd(int range1, int range2);

/*  PURPOSE:  Create a random integer between 0 and a selected range.
    PARAMETERS:  range1 - upper bound
	RETURN:  The random number between 0 and range1								*/
int rnd(int range1);

#endif  /* _RANDOMIZE_H_ */